//+------------------------------------------------------------------+
//|                                                  Regression1.mq4 |
//|                      Copyright  2009, PIP Trading               |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, PIP Trading"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Black
//---- indicator parameters
double ncoef1b[10];
extern int nShift = 0;
extern int pntreg =0;
extern double navg=1.303824353;
extern double nconst1=-0.072862698;
extern double ncoef1b1=-0.069854504;
extern double ncoef1b2=-0.061845198;
extern double ncoef1b3=-0.048756544;
extern double ncoef1b4=-0.030221454;
extern double ncoef1b5=-0.006770416;
extern double ncoef1b6=0.019366506;
extern double ncoef1b7=0.042973633;
extern double ncoef1b8=0.053829378;
extern double ncoef1b9=0.03358148;
extern double ncoef1b10=-0.049028199;
extern double temp=-0.072862698;
//---- indicator buffers
double dRegBuffer[];
double dNexthigh;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(2);
   SetIndexBuffer(0, dRegBuffer);
   SetIndexStyle(0, DRAW_LINE);
   IndicatorShortName("Regression1");
   SetIndexDrawBegin(0, 2);
   SetIndexShift(0,nShift);
   //----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
   int limit;
   int err;
   SetIndexStyle(0, DRAW_LINE, EMPTY, 3, Black);
   double h;
   double newbarval;
   double h0;
   double h1;
   double h2;
   double a;
   double dr0;
   double dr1;
   bool started;
   bool newbar;
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
   if(limit>2)
   started=false;
   else
   started=true;
   if(started==false)
   {
   for(int i = 0; i < limit; i++)
   {
      h=High[i];
      h2=h;
      a=calc(h);
      dRegBuffer[i] = a;
      }
      }
      //if(High[1]!=newbarval)
      //{
      h=High[1];
      a=calc(h);
      dRegBuffer[0] = a;
      newbarval=High[1];
      //}
      //Print(newbarval);
   dr0=dRegBuffer[pntreg];
   dr1=dRegBuffer[1];
   h0=High[0];
   h1=High[1];
   Comment("h= ",h," a= ",a," dr1= ",dr1," dr0= ",dr0," h1= ",h1," h0= ",h0," limit= ",limit);
   
   return(0);
   }
 //+------------------------------------------------------------------+
 
 double calc(double lasthigh)
 {
 double future;
 future=0;
 future=ncoef1b10*MathPow(lasthigh,10);
 future=future+ncoef1b9*MathPow(lasthigh,9);
 future=future+ncoef1b8*MathPow(lasthigh,8);
 future=future+ncoef1b7*MathPow(lasthigh,7);
 future=future+ncoef1b6*MathPow(lasthigh,6);
 future=future+ncoef1b5*MathPow(lasthigh,5);
 future=future+ncoef1b4*MathPow(lasthigh,4);
 future=future+ncoef1b3*MathPow(lasthigh,3);
 future=future+ncoef1b2*MathPow(lasthigh,2);
 future=future+ncoef1b1*lasthigh;
 future=future+nconst1+navg;
 //Print("from calc ",future, lasthigh);
 return(future);
 }